static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xCF, 0xE4, 0x49, 0x1F, 0x1A, 0xEE, 0x8D, 0x30, 0x52, 0xB9,
        0x1A, 0xFD, 0xC3, 0xC1, 0xDE, 0x14, 0xC0, 0xD3, 0x18, 0x2D,
        0x1A, 0x95, 0x7F, 0x47, 0x5B, 0xE0, 0x62, 0xDE, 0xB6, 0x72,
        0xBE, 0x9F, 0x65, 0x4F, 0x6C, 0x45, 0xAA, 0xEE, 0x4E, 0xFE,
        0x36, 0x41, 0x0C, 0x4B, 0xC8, 0x53, 0x4D, 0xC2, 0x22, 0x11,
        0x58, 0x97, 0x30, 0xE5, 0x4D, 0x4B, 0xD4, 0xCB, 0x24, 0x01,
        0x54, 0x90, 0x20, 0xE3
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
